
Namespace GeneticAlgorithm

    Public Class BaseBitChromosome : Implements IChromosome
#Region "Local Variables"
        Protected _fitness As Double = Double.NaN
        Protected _N As Integer = 0
        Protected _bits As BitArray = Nothing
        Protected Shared _random As New Random((Now.Hour * 3600 + Now.Minute * 60 + Now.Second) * 1000 + Now.Millisecond)
#End Region

        Public Sub New(ByVal N As Integer)
            _N = N
            _bits = New BitArray(_N, False)
        End Sub

        Private Sub New()
        End Sub



        Public Sub RandomInit() Implements IChromosome.RandomInit
            'For Each b As Boolean In _bits
            For j As Integer = 0 To _N - 1
                'b = IIf(_random.Next(2) = 1, 1, 0)
                _bits(j) = IIf(_random.Next(2) = 1, 1, 0)
            Next
            'For Each b As Boolean In _bits
            '    Debug.Write(IIf(b, "1", "0"))
            'Next
            'Debug.WriteLine("")
        End Sub


        Protected Sub doCopy(ByVal dest As BaseBitChromosome)
            For j As Integer = 0 To _N - 1
                dest._bits(j) = Me._bits(j)
            Next
        End Sub

        Public Sub Copy(ByVal dest As IChromosome) Implements IChromosome.Copy
            doCopy(dest)
        End Sub

        Protected Sub doCrossover(ByVal dad As BaseBitChromosome, ByVal mom As BaseBitChromosome, ByVal locus As Integer, ByVal offspring1 As BaseBitChromosome, ByVal offspring2 As BaseBitChromosome)
            For j As Integer = 0 To _N - 1
                offspring1._bits(j) = IIf(j <= locus, dad._bits(j), mom._bits(j))
                offspring2._bits(j) = IIf(j <= locus, mom._bits(j), dad._bits(j))
            Next
        End Sub

        Public Sub Crossover(ByVal mother As IChromosome, ByVal offspring1 As IChromosome, ByVal offspring2 As IChromosome) Implements IChromosome.CrossOver
            doCrossover(Me, mother, _random.Next(_N - 1), offspring1, offspring2)
        End Sub

        Public Sub MutateAt(ByVal locus As Integer) Implements IChromosome.MutateAt
            _bits(locus) = Not _bits(locus)
        End Sub

        Public Function ValidLocus(ByVal locus As Integer) As Boolean Implements IChromosome.ValidLocus
            Return locus >= 0 And locus < _N
        End Function
    End Class

End Namespace

