Imports System.Collections.Generic
Imports queentest.GeneticAlgorithm
Namespace GeneticAlgorithm



    Public Class QueenGA : Inherits BaseGeneticAlgorithm(Of QueenChromosome)

        Private _crossoverP As Double = Double.NaN
        Private _mutateP As Double = Double.NaN
        Private _maxiter As Integer = 100
        Private _sideSize As Integer = 8
        Private _NQ As Integer = 8

        Public Event BestObject(ByVal sender As Object, ByVal obj As QueenChromosome)


        Public Sub New(ByVal SideSize As Integer, ByVal NQ As Integer, ByVal maxiter As Integer, ByVal crossoverP As Double, ByVal mutateP As Double)
            _sideSize = SideSize
            _NQ = NQ
            _maxiter = maxiter
            _crossoverP = crossoverP
            _mutateP = mutateP
        End Sub

        Public Function PickBestObject(ByVal population As IEnumerable(Of QueenChromosome)) As QueenChromosome
            Dim maxf As Double = Double.MinValue
            Dim o As QueenChromosome = Nothing
            For Each obj As QueenChromosome In population
                Dim value As Double = GetFitness(obj)
                If value > maxf Then
                    maxf = value
                    o = obj
                End If
            Next
            Return o
        End Function

        Protected Overrides Function CanStop(ByVal iteration As Integer, ByVal population As System.Collections.Generic.List(Of QueenChromosome)) As Boolean
            Debug.WriteLine(String.Format("Iteration={0}", iteration))
            Dim o As QueenChromosome = PickBestObject(population)
            If o IsNot Nothing Then
                Dim ftn As Integer = o.EvalFitness()
                Debug.WriteLine(String.Format("Sum={0}", ftn))
                RaiseEvent BestObject(Me, o)
                Return (iteration >= _maxiter) Or (ftn = 0)
            End If
            Return True
        End Function

        Public Overrides Function CreateChromosome() As QueenChromosome
            Return New QueenChromosome(_sideSize, _sideSize, _NQ)
        End Function

        Public Overrides Function EvalFitness(ByVal obj As QueenChromosome) As Double
            Return obj.EvalFitness()
        End Function

        Protected Overrides Function PerformCrossover() As Boolean
            Return _random.NextDouble <= _crossoverP
        End Function

        Protected Overrides Function PerformMutate() As Boolean
            Return _random.NextDouble() <= _mutateP
        End Function

    End Class
End Namespace