Imports System.Collections.Generic
Imports System.Drawing
Imports queentest.GeneticAlgorithm

Public Class frmQueens

#Region "Local Variables"
    Private WithEvents _ga As QueenGA = Nothing
    Private _queenimg As Bitmap = Nothing
    Private _tblSide As Integer = 8
#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbxTableSize.SelectedIndex = 0
        _tblSide = Integer.Parse(cbxTableSize.Text)
        DrawTable()
        _queenimg = CreateCellImage()


    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        '_tblside =
        _ga = New QueenGA(_tblSide, _tblSide, Integer.Parse(txtIter.Text), 0.8, 0.001)

        Dim population As New List(Of QueenChromosome)
        Dim N As Integer = Integer.Parse(txtSize.Text)
        While population.Count < N
            Dim chromosome As QueenChromosome = _ga.CreateChromosome()
            chromosome.RandomInit()
            population.Add(chromosome)
        End While
        cbxTableSize.Enabled = False
        Try
            _ga.Run(population, True)
        Finally
            cbxTableSize.Enabled = True
        End Try
    End Sub

    Private Sub Handle_BestObject(ByVal sender As Object, ByVal obj As QueenChromosome) Handles _ga.BestObject
        'TextBox1.Text = String.Format("{0}", obj.EvalFitness())
        DrawTable()
        For Each pos As Integer In obj._queens
            Dim r As Integer = pos \ _tblSide
            Dim c As Integer = pos Mod _tblSide
            DrawQueen(r, c)
            'ListBox1.Items.Add(String.Format("{0};{1}", r, c))
        Next
        Application.DoEvents()
    End Sub

    Private Sub DrawQueen(ByVal row As Integer, ByVal col As Integer)
        Dim image1 As Drawing.Bitmap = PictureBox1.Image
        If image1 IsNot Nothing Then
            With image1
                Dim g As Drawing.Graphics = Drawing.Graphics.FromImage(image1)
                Dim br As New Drawing.SolidBrush(Drawing.Color.Black)
                Dim v As Integer = .Width \ _tblSide
                g.FillRectangle(br, col * v, row * v, v, v)
                br.Dispose()
                g.Dispose()
            End With
        End If
    End Sub


    Private Function CreateCellImage() As Bitmap
        Dim r As Drawing.Rectangle = PictureBox1.ClientRectangle
        Dim image1 As New Drawing.Bitmap(r.Width \ _tblSide, r.Height \ _tblSide)
        With image1
            Dim g As Drawing.Graphics = Drawing.Graphics.FromImage(image1)
            Dim br As New Drawing.SolidBrush(Drawing.Color.Black)
            g.FillRectangle(br, 0, 0, .Width, .Height)
            br.Dispose()
            g.Dispose()
        End With
        Return image1
    End Function

    Private Sub DrawTable()
        Dim r As Drawing.Rectangle = PictureBox1.ClientRectangle
        Dim image1 As New Drawing.Bitmap(r.Width, r.Height)
        With image1
            Dim g As Drawing.Graphics = Drawing.Graphics.FromImage(image1)
            Dim br As New Drawing.SolidBrush(Drawing.Color.White)
            g.FillRectangle(br, 0, 0, .Width, .Height)
            Dim myPen As New System.Drawing.Pen(System.Drawing.Color.Black)

            For j As Integer = 1 To _tblSide - 1
                g.DrawLine(myPen, j * .Width \ _tblSide, 0, j * .Width \ _tblSide, .Height - 1)
                g.DrawLine(myPen, 0, j * .Height \ _tblSide, .Width - 1, j * .Height \ _tblSide)
            Next
            myPen.Dispose()
            br.Dispose()
            g.Dispose()
        End With
        PictureBox1.Image = image1
    End Sub


    Private Sub cbxTableSize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxTableSize.SelectedIndexChanged
        _tblSide = Integer.Parse(cbxTableSize.Text)
        DrawTable()
        _queenimg = CreateCellImage()
    End Sub
End Class
